#ifndef __AUTH_H
#define __AUTH_H

#include "client.h"

typedef void (*LoginCallback)(Client *client, const char *user, int success);
typedef void (*AuthCallback)(Client *client, const char *name, int success);

struct _AuthModule {
	char *name;

	void (*init)(void);
	void (*deinit)(void);

	void (*login)(Client *client, const char *user, const char *pass,
		      LoginCallback callback);
	void (*authenticate)(Client *client, AuthCallback callback);

	AuthModule *next;
};

void auth_register(AuthModule *auth);
void auth_unregister(AuthModule *auth);

AuthModule *auth_find(const char *name);

#endif
