#ifndef __MASTER_H
#define __MASTER_H

typedef void (*MasterCallback)(int success, void *user_data);

typedef struct {
	int id;

	uid_t uid;
	gid_t gid;

	char user[64];
	char pass[64];

	char chroot_dir[256];
	char mail[256];

	char login_tag[32];
} MasterRequest;

typedef struct {
	int id;
	int success;
} MasterReply;

/* Request IMAP process for given user/pass. */
void master_send_login(const char *user, const char *pass, int fd,
		       const char *login_tag, MasterCallback callback,
		       void *user_data);

/* Request IMAP process for given uid/gid. user, chroot_dir and mail
   are optional */
void master_send_uid(uid_t uid, gid_t gid, const char *user,
		     const char *chroot_dir, const char *mail, int fd,
		     const char *login_tag, MasterCallback callback,
		     void *user_data);

void master_init(void);
void master_deinit(void);

#endif
